
#ifndef __IIC_H
#define __IIC_H

#include "stdint.h"
#include "gpio.h"
#include "stm32f4xx_hal_gpio.h"

#define SDA_IN(){GPIOB -> MODER &=~(3 <<(9 * 2)); GPIOB -> MODER |= 0 << 9 * 2;}
#define SDA_OUT(){GPIOB -> MODER &=~(3 <<(9 * 2)); GPIOB -> MODER |= 1 << 9 * 2;}

//#define IIC_SCL PBout(8)
//#define IIC_SDA PBout(9)
//#define READ_SDA PBin(9)

#define IIC_SCL_H() HAL_GPIO_WritePin(GPIOB, IIC_SCL_Pin, GPIO_PIN_SET)
#define IIC_SCL_L() HAL_GPIO_WritePin(GPIOB, IIC_SCL_Pin, GPIO_PIN_RESET)
#define IIC_SDA_H() HAL_GPIO_WritePin(GPIOB, IIC_SDA_Pin, GPIO_PIN_SET)
#define IIC_SDA_L() HAL_GPIO_WritePin(GPIOB, IIC_SDA_Pin, GPIO_PIN_RESET)
#define READ_SDA HAL_GPIO_ReadPin(GPIOB, IIC_SDA_Pin)

void IIC_Init(void);
void IIC_Start(void);
void IIC_Stop(void);
void IIC_Send_Byte(uint8_t txd);
uint8_t IIC_Read_Byte(unsigned char ack);
uint8_t IIC_Wait_Ack(void);
void IIC_Ack(void);
void IIC_NAck(void);

void IIC_Write_One_Byte(uint8_t daddr, uint8_t addr, uint8_t data);
uint8_t IIC_Read_One_Byte(uint8_t daddr, uint8_t addr);

#endif
